package clientSide;

import java.awt.*;

import javax.crypto.Cipher;
import javax.crypto.NoSuchPaddingException;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.SocketException;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.Enumeration;
import java.util.Hashtable;

@SuppressWarnings("serial")
public class ClientGUI extends JPanel implements ActionListener, ListSelectionListener, MouseListener
{
	String username;
	String clientType;
    ClientGUI mainGUI;
    String[] listOfNames;
    JFrame frontDisplay;
    JTabbedPane tab;
    static String title = "Panda Chat v0.3";
    static JFrame frame = new JFrame(title);
    JFrame login = new JFrame(title);
    JFrame core = new JFrame(title);
    private JTextField usernameField;
    private JPasswordField passwordField;
    private JTextField serverIP;
    private JTextField port;
    private DataOutputStream outToServer;
    private BufferedReader inFromServer;
    private static PrivateKey privKey;
    private static PublicKey pubKey;
    Hashtable<String, GUINode> chats = new Hashtable<String, GUINode>();
    ShutdownHookThread t = null;
    static boolean once = false;
    CipherHelper ch;
    
    public static void main(String[] args) 
    {
        SwingUtilities.invokeLater(new Runnable() 
        {
            public void run() 
            {
                try 
                {
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                } 
                catch (Exception e) 
                {
                    e.printStackTrace();
                }
                showGUI();
            }
        }
        );
    }

    public ClientGUI()
    {
    	JPanel panOuter = new JPanel(new BorderLayout());
    	JPanel panMiddle = new JPanel();
    	panMiddle.setBorder(BorderFactory.createEmptyBorder(25, 25, 25, 25));
    	JPanel panBottom = new JPanel();
    	panBottom.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    	JLabel welcomeMsg;
    	
    	welcomeMsg = new JLabel("Welcome to Panda Help Desk, please choose one of " +
    			"the following options." + '\n');
    	welcomeMsg.setHorizontalAlignment(JLabel.CENTER);
    	JButton anonymous = new JButton("Anonymous user");
    	anonymous.setActionCommand("anonymous");
    	
    	JButton helpDesk = new JButton("Help-Desk user");
    	helpDesk.setActionCommand("help-desk");
    	
    	anonymous.addActionListener(this);
    	helpDesk.addActionListener(this);
    	
    	JLabel serverJoin = new JLabel("Please enter in the server Name/IP and port number to connect to: ");
    	serverIP = new JTextField("localhost", 10);
    	port = new JTextField("51000", 6);
    	
    	JLabel server = new JLabel("Server Name/IP");
    	server.setLabelFor(serverIP);
    	JLabel portLabel = new JLabel("Port Number");
    	portLabel.setLabelFor(port);
    	
    	panOuter.add(welcomeMsg, BorderLayout.NORTH);
    	panOuter.add(panMiddle, BorderLayout.CENTER);
    	panOuter.add(panBottom, BorderLayout.SOUTH);
    	
    	panMiddle.add(anonymous);
    	panMiddle.add(helpDesk);
    	panBottom.add(serverJoin);
    	panBottom.add(server);
    	panBottom.add(serverIP);
    	panBottom.add(portLabel);
    	panBottom.add(port);
    	add(panOuter);
    }
    
    public void showLogin()
    {
    	JPanel panOuter = new JPanel(new BorderLayout());
    	JPanel panBottom = new JPanel();
    	panBottom.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    	JLabel welcomeMsg;
    	
    	welcomeMsg = new JLabel("Please enter your username and password and press login");
    	welcomeMsg.setHorizontalAlignment(JLabel.CENTER);
    	
        usernameField = new JTextField(10);
        passwordField = new JPasswordField(10);
    	
    	JLabel username = new JLabel("Username");
        username.setLabelFor(usernameField);
        JLabel password = new JLabel("Password");
        password.setLabelFor(passwordField);
        
        JButton loginButton = new JButton("Login");
        loginButton.setActionCommand("login");
        loginButton.addActionListener(this);
    	
        JButton backButton = new JButton("Back");
        backButton.setActionCommand("back");
        backButton.addActionListener(this);
        
    	panOuter.add(welcomeMsg);
    	panOuter.add(panBottom, BorderLayout.SOUTH);
    	
    	panBottom.add(backButton);
    	panBottom.add(username);
    	panBottom.add(usernameField);
    	panBottom.add(password);
    	panBottom.add(passwordField);
    	panBottom.add(loginButton);
    	
    	login.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	login.setContentPane(panOuter);
    	login.setSize(500, 300);
    	login.setVisible(true);
    }
    
    public static void showGUI()
    {
    	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	
    	ClientGUI clientSide = new ClientGUI();
    	
    	frame.setContentPane(clientSide);
    	frame.setSize(700, 220);
    	frame.setVisible(true);
    	pubKey = generateRSA();
    }
    
    public void actionPerformed(ActionEvent e)
    {
    	if (e.getActionCommand().equals("help-desk"))
    	{
    		//System.out.println("Help-desk pressed");
    		frame.setVisible(false);
    		showLogin();
    	}
    	else if (e.getActionCommand().equals("back"))
    	{
    		login.setVisible(false);
    		showGUI();
    	}
    	else if (e.getActionCommand().equals("login"))
    	{    		
    		if ((usernameField.getText().length() > 0) || 
    			(passwordField.getPassword().length > 0))
    		{	
    			try
				{
					connectServer("help-desk");
				} 
    			catch (IOException e1)
				{
					e1.printStackTrace();
				}
    		}
    	}
    	else if (e.getActionCommand().equals("anonymous"))
    	{
    		//System.out.println("Anonymous pressed");
    		try
			{
				connectServer(e.getActionCommand());
			} catch (IOException e1)
			{
				e1.printStackTrace();
			}
    	}
    }
    
    public void connectServer(String type) throws IOException
    {
		String servName = "";
		int socket = 0;
		SSLSocket sslSocket = null;
		byte[] publicKeyBytes;
		try
		{ //Attempts to connect to the server on the given socket
			
			ch = new CipherHelper();
			ch.setPrivKey(privKey);
			
			publicKeyBytes = pubKey.getEncoded();

			if (!new File(".\\res\\mySrvKeystore").isFile())
			{
				JOptionPane.showMessageDialog(frame, "keystore not located in .\\res\\keystore");
				System.exit(0);
			}
			
			System.setProperty("javax.net.ssl.trustStore", ".\\res\\mySrvKeystore");
		    System.setProperty("javax.net.ssl.trustStorePassword", "123456");
		    SSLSocketFactory sslsocketfactory = (SSLSocketFactory) SSLSocketFactory.getDefault();
		    
			socket = Integer.parseInt(port.getText());
			servName = serverIP.getText();
			sslSocket = (SSLSocket) sslsocketfactory.createSocket(servName, socket);
		}
		catch (Exception e)
		{ //If server doesn't exist, inform the user
			System.out.println("Unable to connect..............");
			System.out.println("You may have put in the wrong server information");
			System.out.println();
			JOptionPane.showMessageDialog(frame, "Unable to connect, please check server information again");
			return;
		}
		outToServer = new DataOutputStream(sslSocket.getOutputStream());
		inFromServer = new BufferedReader(new InputStreamReader(sslSocket.getInputStream()));
		//Create thread that acts if program is shut down irregularly
		if (t == null)
		{ //Ensure the shutdownhook is only created once
			t = new ShutdownHookThread(this, sslSocket, outToServer);
			Runtime.getRuntime().addShutdownHook(t);
		}
		else
		{
			t.setClientGUI(this);
			t.setClientSocket(sslSocket);
			t.setOutToServer(outToServer);
		}
		try
		{	
			String temp;
			outToServer.writeBytes(type + '\n');
			outToServer.writeBytes(publicKeyBytes.length + "" + '\n');
			outToServer.write(publicKeyBytes);
			outToServer.flush();
			
			//Read server public key 
			ch.setPubKey(this.getServerKey(inFromServer, sslSocket));
			
			if (type.equals("anonymous"))
			{
				temp = this.readIncoming(inFromServer, sslSocket);
				//System.out.println(temp);
				String tempArray[] = temp.split(":", 2);
				if ((tempArray.length >= 2) && (tempArray[0].equals("Server")))
				{
					if (temp.endsWith("!"))
					{
						//Thread t = new ShutdownHookThread(clientSocket, outToServer);
						//Runtime.getRuntime().addShutdownHook(t);
						tempArray = tempArray[1].split(" ");
						username = tempArray[tempArray.length - 1].substring(0, tempArray[tempArray.length-1].length() - 1);
						temp = this.readIncoming(inFromServer, sslSocket);
						tempArray = temp.split(" ", 5);
						GUINode node = new GUINode(tempArray[2]);
						chats.put(tempArray[2], node);
						clientType = type;
						coreDisplay(tempArray[2]); /** consider ordering of calls **/
						
						this.showTxt(temp);
						//Create thread to constantly read input from server
						NewThreadIn x = new NewThreadIn(this, sslSocket, inFromServer, privKey);
						Thread n = new Thread(x);
						n.start();
					}
					else
					{ //Doesn't work too well since System.exit(0) is used to kill all
						JOptionPane.showMessageDialog(frame, tempArray[1]);
					}
				}
				
			}
			else
			{ //Changes to help-desk agent mode
				//System.out.println(usernameField.getText());
				//outToServer.writeBytes(usernameField.getText() + '\n');
				this.sendEncrypted(usernameField.getText());
				String holder = "";
				for (char letter : passwordField.getPassword())
				{
					holder += letter;
				}
				//outToServer.writeBytes(this.calculateHash(holder) + '\n');
				this.sendEncrypted(this.calculateHash(holder));
				temp = this.readIncoming(inFromServer, sslSocket);

				if (temp.equals("Server:SUCCESSFUL REGISTRATION"))
				{
					//Thread t = new ShutdownHookThread(clientSocket, outToServer);
					//Runtime.getRuntime().addShutdownHook(t);
					username = usernameField.getText();
					clientType = type;
					GUINode node = new GUINode(username);
					chats.put("Main", node);
					
					coreDisplay(null);
					this.showTxt(temp);
					//Create thread to constantly read input from server
					NewThreadIn x = new NewThreadIn(this, sslSocket, inFromServer, privKey);
					Thread n = new Thread(x);
					n.start();
				}
				else if (temp.startsWith("Server:Incorrect username or password"))
				{ //Rewritten this part based on a fail back from server
					//Attempt to write it into the Frame
					JOptionPane.showMessageDialog(frame, "Invalid username or password, please try again");
				}
				else if (temp.startsWith("Server:Too many login attempts, account has been locked for"))
				{
					JOptionPane.showMessageDialog(frame, temp);
				}
			}
		}
		catch (SocketException e)
		{ //In case proper shut down isn't recieved from server
			System.out.println("Whoa server is missing! Better close the socket");
			sslSocket.close();
		}
    }
    
    private static PublicKey generateRSA()
	{
    	if (!once)
    	{
    		KeyPairGenerator keyPairGenerator;
    		KeyPair keyPair;
    		try
    		{
    			keyPairGenerator = KeyPairGenerator.getInstance("RSA");
    			keyPairGenerator.initialize(1024);
    			keyPair = keyPairGenerator.genKeyPair();
    			privKey = keyPair.getPrivate();
    			return keyPair.getPublic();
		    
    		} catch (NoSuchAlgorithmException e)
    		{
    			JOptionPane.showMessageDialog(frame, "Problems with generating RSA keys. " +
    					"Cannot continue operation without generating keys.");
    			System.exit(0);
    		}
    		once = true;
    	}
    		return null;
	}

	public String calculateHash(String data) {
    	String hashData = null;
		try
		{
			MessageDigest md;
			md = MessageDigest.getInstance("SHA-256");
			
			byte[] bytes = md.digest(data.getBytes());
            StringBuilder sb = new StringBuilder();
            for(int i=0; i< bytes.length ;i++)
            {
                sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
            }
            hashData = sb.toString();
		} catch (NoSuchAlgorithmException e)
		{
			System.out.println("Error: Algo SHA-256 does not exist");
		}
		return hashData;
        
    }
    
    public void showTxt(String text)
	{
    	String parse[] = text.split(":", 2);
    	if (!parse[0].equals("Server"))
    	{
    		chats.get(parse[0]).getChatBox().append("<" + parse[0] + ">: " + parse[1].trim()
    				+ "\n");
        	//chats.get(parse[0]).getMessageBox().setText("");
        	//chats.get(parse[0]).getMessageBox().requestFocusInWindow();
    	}
    	else if (parse[0].equals("Server"))
    	{
    		Enumeration<GUINode> enumeration = chats.elements();
    	    GUINode node = null;
    	    while (enumeration.hasMoreElements())
    	    {
    	    	node = (GUINode) enumeration.nextElement();
    	    	node.getChatBox().append("<" + parse[0] + ">: " + parse[1].trim()
        				+ "\n");
            	//node.getMessageBox().setText("");
    	    }
    	}
	}
    
	public void coreDisplay(String type) 
    {
		tab = new JTabbedPane();
		core.getContentPane().add(tab, BorderLayout.CENTER);
		
		if (type != null)
			makeTab(type);
		else
			makeTab("Main");
		
        frame.setVisible(false);
        login.setVisible(false);
        core.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        core.setSize(500, 300);
        core.setVisible(true);
    }
    
	public void makeTab(String tabName)
	  {
		  JPanel panel2 = new JPanel();
		  
		  JPanel mainPanel = new JPanel();
	      mainPanel.setLayout(new BorderLayout());

	      JPanel southPanel = new JPanel();
	      southPanel.setLayout(new GridBagLayout());
	      
	      JTextArea chatBox = new JTextArea();
	      chatBox.setEditable(false);
	      chatBox.setLineWrap(true);
	      
	      JTextField messageBox = new JTextField(30);
	      messageBox.requestFocusInWindow();
	      
	      JButton sendMessage = new JButton("Send Message");
	      
	      panel2.setLayout(new BorderLayout(0, 0));
	      
	      GridBagConstraints left = new GridBagConstraints();
	      left.insets = new Insets(10, 10, 10, 0);
	      left.anchor = GridBagConstraints.LINE_START;
	      left.fill = GridBagConstraints.HORIZONTAL;
	      left.weightx = 52.0;
	      left.weighty = 1.0;

	      GridBagConstraints right = new GridBagConstraints();
	      right.insets = new Insets(10, 10, 10, 10);
	      right.anchor = GridBagConstraints.LINE_END;
	      right.fill = GridBagConstraints.NONE;
	      right.weightx = 1.0;
	      right.weighty = 1.0;
	      
	      GUINode node = new GUINode(tabName, chatBox, messageBox, sendMessage);
	      chats.put(tabName, node);
	      node.getMessageBox().addActionListener(new sendMessageButtonListener(node));
	      node.getSendMessage().addActionListener(new sendMessageButtonListener(node));
	      mainPanel.add(new JScrollPane(chatBox), BorderLayout.CENTER);
	      if (clientType.equals("help-desk"))
	      {
	    	  this.addSidePanel(node);
		      this.refreshList(listOfNames);
	    	  mainPanel.add(node.getListScrollPane(), BorderLayout.EAST);
	      }

	      southPanel.add(messageBox, left); 
	      southPanel.add(sendMessage, right);
	      mainPanel.add(southPanel, BorderLayout.SOUTH);
	      
	      panel2.add(mainPanel);
	      tab.add(tabName, panel2);
	  }
	
	public boolean chatExists(String name)
	{ //True if chat tab with name exists, false otherwise
		return (chats.get(name) != null);
	}
	
	public boolean tabExists(String name)
	{
		for (int i = 0; i < this.tabCount(); i++)
		{
			if (tab.getTitleAt(i).equals(name))
				return true;
		}
		return false;
	}
	
	public int tabCount()
	{
		return tab.getTabCount();
	}
	
	public void removeTab(String name)
	{
		for (int i = 0; i < this.tabCount(); i++)
		{
			if (tab.getTitleAt(i).equals(name))
			{
				tab.remove(i);
				chats.remove(name);
			}
		}
	}
	
	public void disableMsg(String name)
	{
		chats.get(name).messageBox.setEnabled(false);
		chats.get(name).sendMessage.setEnabled(false);
	}
	
	public void enableMsg(String name)
	{
		chats.get(name).messageBox.setEnabled(true);
		chats.get(name).sendMessage.setEnabled(true);
	}
	
	public void disableAllMsg()
	{
		Enumeration<GUINode> enumeration = chats.elements();
		
	    GUINode node = null;
	    while (enumeration.hasMoreElements())
	    {
	    	node = (GUINode) enumeration.nextElement();
	    	node.messageBox.setEnabled(false);
	    	node.sendMessage.setEnabled(false);
	    }
	}
	
    class sendMessageButtonListener implements ActionListener 
    {
    	GUINode node = null;
    	
        public sendMessageButtonListener(GUINode node)
		{
			this.node = node;
		}

		public void actionPerformed(ActionEvent event) 
        {
            if (node.getMessageBox().getText().length() < 1) 
            { /* do nothing */ } 
            else if (node.getMessageBox().getText().equals(".clear")) 
            {
                node.getChatBox().setText("Cleared all messages\n");
                node.getMessageBox().setText("");
            } 
            else 
            {
                if (node.getMessageBox().getText().matches(".*-transfer:.*"))
				{
					//outToServer.writeBytes(node.getMessageBox().getText() + '\n');
					sendEncrypted(node.getMessageBox().getText());
				}
				else
				{
					node.getChatBox().append("<" + username + ">: " +	
							node.getMessageBox().getText() + "\n");
					int indexSelected = tab.getSelectedIndex();
					String outTo = tab.getTitleAt(indexSelected);
					//outToServer.writeBytes(outTo+":"+node.getMessageBox().getText() + '\n');
					sendEncrypted(outTo+":"+node.getMessageBox().getText());
				}
                node.getMessageBox().setText("");
                
            }
            node.getMessageBox().requestFocusInWindow();
        }
    }

	@Override
	public void valueChanged(ListSelectionEvent e)
	{}
	
	public void addSidePanel(GUINode node)
	{
		DefaultListModel listModel = new DefaultListModel();
	    //listModel.addElement("Temp Name");
	    //listModel.addElement("Another name");
	    //Create the list and put it in a scroll pane.
	    JList list = new JList(listModel);
	    list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	    list.setSelectedIndex(0);
	    list.addListSelectionListener(this);
	    list.setVisibleRowCount(15);
	    list.addMouseListener(this);
	    JScrollPane listScrollPane = new JScrollPane(list);
	    node.setSidePanel(listModel, list, listScrollPane);
	}
	
	public void refreshList(String[] listOfNames)
	{
		this.listOfNames = listOfNames;
		DefaultListModel listModel = null;
		String tempNames = ":";
		
		Enumeration<GUINode> enumeration = chats.elements();
		
	    GUINode node = null;
	    while (enumeration.hasMoreElements())
	    {
	    	node = (GUINode) enumeration.nextElement();
	    	listModel = node.getListModel();
	    	
	    	listModel.removeAllElements();
	    	if (this.listOfNames != null)
	    	{
	    		for (String name : this.listOfNames)
	    		{
	    			listModel.addElement(name);
	    			tempNames += name + ":";
	    		}
	    		System.out.println("");
	    	}
	    }
	    if (this.listOfNames != null)
	    {
	    	for (int i = 0; i < this.tabCount(); i++)
	    	{
	    		if ((!tempNames.contains(":" + tab.getTitleAt(i) + ":")) &&
	    				!(tab.getTitleAt(i).matches("Anonymous[0-9]+")))
	    			this.disableMsg(tab.getTitleAt(i));
	    		else
	    			this.enableMsg(tab.getTitleAt(i));
	    	}
	    }
	}

	@Override
	  public void mouseClicked(MouseEvent mouseEvent)
	  {
	    JList theList = (JList) mouseEvent.getSource();
	    if (mouseEvent.getClickCount() == 2) 
	    {
	      int index = theList.locationToIndex(mouseEvent.getPoint());
	      if (index >= 0) 
	      {
	        Object o = theList.getModel().getElementAt(index);
	        //System.out.println("Double-clicked on: " + o.toString());
	        if ((!this.tabExists(o.toString())) && !(o.toString().equals(username)))
	        	this.makeTab(o.toString());
	        
	        for (int i = 0; i < this.tabCount(); i++)
			{
				if (tab.getTitleAt(i).equals(o.toString()))
					 tab.setSelectedIndex(i);
			}
	       
	      }
	    }
	  }

	@Override
	public void mousePressed(MouseEvent e)
	{
	}

	@Override
	public void mouseReleased(MouseEvent e)
	{
	}

	@Override
	public void mouseEntered(MouseEvent e)
	{
	}

	@Override
	public void mouseExited(MouseEvent e)
	{
	}
	
	public void sendEncrypted(String text)
	{
		try
		{
			byte[] temp = ch.encrypt(text);
			outToServer.writeBytes(""+temp.length+'\n');
			outToServer.write(temp);
			outToServer.flush();
		}
		catch (IOException e)
		{} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public String readIncoming(BufferedReader dataIn, Socket clientSocket) 
	{
		int len;
		try
		{
			len = Integer.parseInt(dataIn.readLine());
			byte[] tempBytes = new byte[len];
			for (int i = 0; i < len; i++)
			{
				tempBytes[i] = (byte) clientSocket.getInputStream().read();
			}
			return ch.decrypt(tempBytes);
		} catch (NumberFormatException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		} catch (Exception e)
		{
			System.out.println("readIncoming: exception e");
			e.printStackTrace();
		}
		System.out.println("readIncoming (ClientGUI) is returning a NULL value!");
		return null;
	}
	
	public PublicKey getServerKey(BufferedReader inFromClient,
			Socket connectionSocket)
	{
		KeyFactory keyFactory;
		try
		{
			int len;
			len = Integer.parseInt(inFromClient.readLine());
			byte[] tempBytes = new byte[len];
			for (int i = 0; i < len; i++)
			{
				tempBytes[i] = (byte) connectionSocket.getInputStream().read();
			}
			keyFactory = KeyFactory.getInstance("RSA");
			KeySpec keySpec = new X509EncodedKeySpec(tempBytes);
		    return keyFactory.generatePublic(keySpec);
		} catch (NoSuchAlgorithmException e)
		{
			//e.printStackTrace();
		} catch (InvalidKeySpecException e)
		{
			//e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		System.out.println("getClientKey (Server) is returning a NULL value!");
		return null;
	}
}