package serverSide;

import java.io.BufferedReader;
import java.io.IOException;
import java.net.Socket;
import java.security.PrivateKey;
import java.util.Hashtable;

/* 
New thread created by a thread to make the accepting of chat easier 
Handles the timeout feature so one user cannot easily lock out another
*/

class NewThreadIncoming implements Runnable 
{
	private ChatServer server;
	private Socket connectionSocket;
	private BufferedReader inFromClient;
	private String type = "";
	private Thread m;
	
	NewThreadIncoming(ChatServer server, Socket connectionSocket, BufferedReader inFromClient) 
	{
		this.server = server; //Needed as we will be calling upon methods which
		//will require us to know who spawned this thread
		this.connectionSocket = connectionSocket;//pass connection socket
		this.inFromClient = inFromClient;
	}

	public void run()
	{
		NewThread w;
		NewThreadAnon w2;
		NewThreadTimeout w3;
		
		try 
		{
			Thread m3;
			w3 = new NewThreadTimeout(m, this, inFromClient, server);
			m3 = new Thread(w3);
			m3.start();

			Thread.sleep(2000);

			//inFromClient.close();
			
			type = "";
			String ipAddress = connectionSocket.getRemoteSocketAddress().toString();
			ipAddress = ipAddress.split(":", 2)[0].toString().substring(1);
			
			server.removeUnknown(ipAddress, connectionSocket);
			connectionSocket.close();
			//System.out.println("A connection timed out: " + connectionSocket.isClosed());
		}
		catch (InterruptedException e)
		{
			//System.out.println("Interrupted exception");
			String ipAddress = connectionSocket.getRemoteSocketAddress().toString();
			ipAddress = ipAddress.split(":", 2)[0].toString().substring(1);
			
			server.removeUnknown(ipAddress, connectionSocket);
			
			if (type.equals("anonymous"))
			{
				w2 = new NewThreadAnon(server, connectionSocket, inFromClient);
				Thread m = new Thread(w2);
				m.start(); //start new thread to allow multiple connections to port**/
			}
			else if (type.equals("help-desk"))
			{
				w = new NewThread(server, connectionSocket, inFromClient);
				Thread m = new Thread(w);
				m.start(); //start new thread to allow multiple connections to port**/
			}
			
		} catch (IOException e)
		{
			System.out.println("IO exception");
		}
		catch (Exception e)
		{
			System.out.println("Something got weird");
			e.printStackTrace();
		}
	}
	
	public Socket getConnectionSocket()
	{
		return connectionSocket;
	}

	public void setType(String type)
	{
		this.type = type;
	}

	public void setThread(Thread m)
	{
		this.m = m;
	}
}
