package serverSide;

import java.net.ServerSocket;

/* Thread is started at the beginning in case server is improperly shutdown.
Informs users to graceful shutdown and then shuts itself down */

class ShutdownHookServer extends Thread
{
	ServerSocket serverSocket;
	ChatServer server;
	ShutdownHookServer(ChatServer server, ServerSocket socket)
	{
		this.server = server;
		this.serverSocket = socket;
	}
	
	public void run()
	{
		try
		{
			System.out.println();
			System.out.println("Server shutting down.......");
			System.out.println("Informing all connected users.......");
			server.list(null, 0); //Finds users in hashtable and send them Good Bye
			serverSocket.close(); //Closes itself
			while(!serverSocket.isClosed())
				{} //Loops until server is no longer listening
			System.out.println("Server is no longer active and listening.");
		}
		catch (Exception e) {}
	}
}