package clientSide;

import java.io.BufferedReader;
import java.net.Socket;
import java.security.PrivateKey;

//This thread is used to constantly look for incoming data from server
class NewThreadIn implements Runnable
{
	private BufferedReader dataIn;
	private Socket clientSocket;
	private ClientGUI frame;
	
	NewThreadIn(ClientGUI clientGUI, Socket clientSocket, BufferedReader dataIn, PrivateKey privKey)
	{
		this.frame = clientGUI;
		this.clientSocket = clientSocket;
		this.dataIn = dataIn;
	}
	
	public void run()
	{
		try
		{
			String message = "";
			String[] temp = null;
			Boolean loop = true;
			Boolean skip = false;
			while (loop)
			{
				message = frame.readIncoming(dataIn, clientSocket);
				if (message.split(":", 3).length == 3)
				{
					temp = message.split(":", 3);
					if ((temp[0].equals("Server")) && (temp[1].equals("List")))
					{
						frame.refreshList(temp[2].split(":"));
						skip = true;
					}
				}
					/** ENSURE IN RECIEVING A MSG THE TAB EXISTS
					 * ELSE TRIGGER METHOD TO CREATE IT
					 * ---tempNode.getOutput().writeBytes("Server:"+name+" has left the chat.");
					 * 
					 * ---node.getOutput().writeBytes("Server:User '"+ name + "' has been assigned to you." + '\n');
					 * ---outToClient.writeBytes("Server:Help-Desk Agent " + deskNode.name + " has been assigned to you." + '\n');
					 * 						
					 * ---Anon.getOutput().writeBytes("Server:You have been transferred to: '" + HDU.name + "'." + '\n');
					 * ---HDU.getOutput().writeBytes("Server:User '"+ Anon.name + "' has been transferred to you." + '\n');
					 * previousHDU.getOutput().writeBytes("Server:"+Anon.name+ " has been successfully transferred." + '\n');
					 */
				//System.out.println(message);
				if (message.startsWith("Server:User '"))
				{ //Dealing with incoming to HDU
					temp = message.split("'", 3);
					if (!frame.tabExists(temp[1]))
						frame.makeTab(temp[1]);
					else
						frame.enableMsg(temp[1]);
					
					if (frame.tabExists("Main"))
						frame.removeTab("Main");
				}
				else if (message.startsWith("Server:Help-Desk Agent "))
				{ //Dealing with initial Anon to HDU assignment
					temp = message.split(" ", 4);
					if (!frame.tabExists(temp[2]))
						frame.makeTab(temp[2]);
					if (frame.tabExists("Main"))
						frame.removeTab("Main");
				}
				else if ((message.endsWith(" has left the chat.")) ||
						(message.endsWith(" has been successfully transferred.")))
				{
					String name = message.split(" ", 2)[0].substring(7);
					frame.disableMsg(name);
				}
				else if (message.startsWith("Server:You have been transferred to: "))
				{
					String name = message.split("'", 3)[1];
					frame.disableAllMsg();
					if (!frame.tabExists(name))
						frame.makeTab(name);
					else
						frame.enableMsg(name);
				}
				else if (message.startsWith("ServerCmd:"))
				{
					if (!frame.tabExists(message.split(":", 2)[1]))
						frame.makeTab(message.split(":", 2)[1]);
				}
				
				if ((!message.split(":")[0].equals("ServerCmd")) && !skip)
					frame.showTxt(message);
				//Good Bye is used as a command from server to end the program
				if (message.equals("Server:Good Bye"))
				{ /**Instead of closing, could just lock the chat box and disconnect from server **/
					clientSocket.close();
					System.out.println();
					System.out.println("Please wait as socket is properly closed...");
					while (!clientSocket.isClosed())
						{}
					System.out.println("Thank you for waiting, program will now exit");
					System.exit(0);
				}
				skip = false;
			}
		}
		catch (Exception e) {}
	}
}