package serverSide;

import java.io.*;
import java.net.*;
import java.security.PublicKey;
import java.util.*;

import javax.net.ssl.SSLSocket;

public class Node
{
	private String name; //Name of user this node represents
	private DataOutputStream outToClient; //The DataOutputStream of user
	private boolean admin = false; //Not currently used, would mark Administrators
	private String ipAddress;
	private int attempts = 0; //login attempts
	private long lockTimer = 0; //will hold time of when IP was blocked
	private int unknown = 0; 
	private List<SSLSocket> connectList = new ArrayList<SSLSocket>();
	private PublicKey pubKey;
	
	public PublicKey getPubKey()
	{
		return pubKey;
	}

	public void setPubKey(PublicKey pubKey)
	{
		this.pubKey = pubKey;
	}

	public List<SSLSocket> getConnectList()
	{
		return connectList;
	}
	
	public int getUnknown()
	{
		return unknown;
	}

	public void setUnknown(int unknown)
	{
		this.unknown = unknown;
	}

	public int getAttempts()
	{
		return attempts;
	}

	public void setAttempts(int attempts)
	{
		this.attempts = attempts;
	}

	public long getLockTimer()
	{
		return lockTimer;
	}

	public void setLockTimer(long lockTimer)
	{
		this.lockTimer = lockTimer;
	}

	public String getIpAddress()
	{
		return ipAddress;
	}

	public void setIpAddress(String ipAddress)
	{
		this.ipAddress = ipAddress;
	}

	int count;
	
	public int getCount()
	{
		return count;
	}

	public void setCount(int count)
	{
		this.count = count;
	}

	public Node()
	{
		this(null, null);
	}
	
	public Node(String name, DataOutputStream outStream)
	{
		this.name = name;
		this.outToClient = outStream;
	}
	
	public void setName(String name)
	{
		this.name = name;
	}
	
	public void setOuput(DataOutputStream outToClient)
	{
		this.outToClient = outToClient;
	}
	
	public void setAdmin(boolean value)
	{
		this.admin = value;
	}
	
	public boolean getAdmin()
	{
		return this.admin;
	}
	
	public DataOutputStream getOutput()
	{
		return this.outToClient;
	}

	public String getName()
	{
		return this.name;
	}
}